---
title: AudioBufferSourceNode.playbackRate
slug: Web/API/AudioBufferSourceNode/playbackRate
tags:
  - API
  - AudioBufferSourceNode
  - Property
  - Reference
  - Web Audio API
  - playbackRate
---
<p>{{ APIRef("Web Audio API") }}</p>

<div>
<p><span class="seoSummary">The <strong><code>playbackRate</code></strong> property of the {{ domxref("AudioBufferSourceNode") }} interface Is a <a href="/en-US/docs/DOM/AudioParam#k-rate">k-rate</a> {{domxref("AudioParam")}} that defines the speed at which the audio asset will be played.</span></p>

<p>A value of 1.0 indicates it should play at the same speed as its sampling rate, values less than 1.0 cause the sound to play more slowly, while values greater than 1.0 result in audio playing faster than normal. The default value is <code>1.0</code>. When set to another value, the <code>AudioBufferSourceNode</code> resamples the audio before sending it to the output.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>AudioBufferSourceNode</em>.playbackRate.value = <em>playbackRateProportion</em>;
</pre>

<h3 id="Value">Value</h3>

<p>An {{domxref("AudioParam")}} whose {{domxref("AudioParam.value", "value")}} is a floating-point value indicating the playback rate of the audio as a decimal proportion of the original sampling rate.</p>

<p>Consider a sound buffer containing audio sampled at 44.1 kHz (44,100 samples per second). Let's see what a few values of <code>playbackRate</code> do:</p>

<ul>
 <li>A <code>playbackRate</code> of 1.0 plays the audio at full speed, or 44,100 Hz.</li>
 <li>A <code>playbackRate</code> of 0.5 plays the audio at half speed, or 22,050 Hz.</li>
 <li>A <code>playbackRate</code> of 2.0 doubles the audio's playback rate to 88,200 Hz.</li>
</ul>

<h2 id="Example">Example</h2>

<p>In this example, the {{domxref("AudioContext.decodeAudioData()")}} function is used to decode an audio track, and put it into an {{domxref("AudioBufferSourceNode")}}. Buttons are provided to play and stop the audio playback, and a slider control is used to change the <code>playbackRate</code> property value on the fly.</p>

<div class="note">
<p>You can <a class="external external-icon" href="https://mdn.github.io/webaudio-examples/decode-audio-data/">run the example live</a> (or <a class="external external-icon" href="https://github.com/mdn/webaudio-examples/tree/master/decode-audio-data">view the source</a>.) Play the song and alter the playback rate for some fun results.</p>
</div>

<pre class="brush: html">&lt;input class="playback-rate-control" type="range" min="0.25" max="3" step="0.05" value="1"&gt;
&lt;span class="playback-rate-value"&gt;1.0&lt;/span&gt;
</pre>

<pre class="brush: js;highlight[15]">function getData() {
  source = audioCtx.createBufferSource();
  request = new XMLHttpRequest();

  request.open('GET', 'viper.ogg', true);

  request.responseType = 'arraybuffer';

  request.onload = function() {
    var audioData = request.response;

    audioCtx.decodeAudioData(audioData, function(buffer) {
        myBuffer = buffer;
        source.buffer = myBuffer;
        source.playbackRate.value = playbackControl.value;
        source.connect(audioCtx.destination);
        source.loop = true;
      },

      function(e){"Error with decoding audio data" + e.err});

  }

  request.send();
}

// wire up buttons to stop and play audio, and range slider control

play.onclick = function() {
  getData();
  source.start(0);
  play.setAttribute('disabled', 'disabled');
  playbackControl.removeAttribute('disabled');
}

stop.onclick = function() {
  source.stop(0);
  play.removeAttribute('disabled');
  playbackControl.setAttribute('disabled', 'disabled');
}

playbackControl.oninput = function() {
  source.playbackRate.value = playbackControl.value;
  playbackValue.innerHTML = playbackControl.value;
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audiobuffersourcenode-playbackrate', 'playbackRate')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioBufferSourceNode.playbackRate")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
